%if 0%{?suse_version}
%define mysqld mysql
%define daemon_group www
%else
%define mysqld mysqld
%define daemon_group apache
%endif
%if 0%{?rhel} >= 7
%define init_scripts --enable-initscripts=no
%else
%define init_scripts %{nil}
%endif
Name: op5-trapper-processor
Version: %{op5version}
Release: %{op5release}
License: GPLv2
Packager: build@op5
Vendor: op5 AB
BuildRoot: %{_tmppath}/%{name}-%{version}
Summary: SNMP traps processing daemon
Group: op5/trapper
BuildRequires: autoconf, automake
BuildRequires: lua-devel
BuildRequires: perl(DBD::mysql)
BuildRequires: perl(Test::More)
BuildRequires: perl-DBI
BuildRequires: op5-mysql
BuildRequires: op5-trapper-collector
Requires: op5-trapper-luapack >= 1.0.1-beta1
Requires: op5-trapper-collector
Requires: op5-mysql
Requires: op5-monitor-user
Requires: lua
%if 0%{?suse_version}
BuildRequires: libdbi-devel
BuildRequires: libdbi-drivers-dbd-mysql
BuildRequires: pkg-config
Requires: libdbi1
Requires: libdbi-drivers-dbd-mysql
Requires(post): mysql-client
%else
BuildRequires: libdbi-devel
BuildRequires: libdbi-dbd-mysql
BuildRequires: pkgconfig
Requires: libdbi
Requires: libdbi-dbd-mysql
%endif
%if 0%{?rhel} >= 7
BuildRequires: systemd
BuildRequires: mariadb-devel
%endif
Source: %name-%version.tar.gz
Source1: init.patch

%description
Processes SNMP traps according to user defined rules.

%prep
rm -rf %buildroot
%setup -q
%if 0%{?suse_version}
patch -p1 < %_sourcedir/init.patch
%endif

%build
./autogen.sh
%configure %init_scripts
make

%install
%make_install
mkdir -p %buildroot/opt/trapper/bin/
ln -s ../../../usr/bin/traped %buildroot/opt/trapper/bin/traped
mkdir -p %buildroot/opt/trapper/share/lua/
ln -s ../../../../%_datadir/processor/extra.lua %buildroot/opt/trapper/share/lua/extra.lua
%if 0%{?rhel} >= 7
mkdir --parents %{buildroot}%{_unitdir}
cp op5build/processor.service %{buildroot}%{_unitdir}/processor.service
%endif

%check
%if 0%{?rhel} >= 7
%else
make distcheck
%endif

%post
%if 0%{?rhel} >= 7
systemctl is-enabled mariadb >/dev/null || systemctl start mariadb
mysql --user=trapper --password=trapper trapper < %_datadir/processor/processor.sql
systemctl daemon-reload
systemctl enable processor.service
systemctl restart processor
%else
service %mysqld status >/dev/null || service %mysqld start
mysql --user=trapper --password=trapper trapper < %_datadir/processor/processor.sql
chkconfig --add processor
service processor restart
%endif

%preun
if [ "$1" -eq 0 ]; then
%if 0%{?rhel} >= 7
	systemctl stop processor
	systemctl disable processor.service
	systemctl daemon-reload
%else
	service processor stop
	chkconfig --del processor
%endif
fi

%files
%defattr(0644,root,root,0755)
%if 0%{?rhel} >= 7
%attr(664, root, root) %{_unitdir}/processor.service
%else
%attr(0755,root,root) %_sysconfdir/init.d/processor
%endif
%attr(0755,root,root) %_bindir/processor
%attr(0755,root,root) %_bindir/traped
%_datadir/processor/extra.lua
%_datadir/processor/processor.sql

# compatibility stuff
%attr(0755,root,root) /opt/trapper/bin/traped
%attr(0755,root,root) /opt/trapper/share/lua/extra.lua

%attr(0640,monitor,%daemon_group) %config(noreplace) %_sysconfdir/processor/processor.conf

%clean
rm -rf %buildroot
